#############################################################################
# Visual Tcl v1.11 Project
# Pretty TCL 
# by William B. Wilborn 
# Wbwchief@accessus.net

#################################
# GLOBAL VARIABLES
#
global inFileName;
global indentglobal;
global indentproc;
global nrspaces;
global outFileName;
global widget;

#################################
# USER DEFINED PROCEDURES
#
proc init {argc argv} {
  
}

 init $argc $argv


proc MakeItPretty {} {
global indentglobal;
global indentproc;
global inFileName;
global nrspaces;
global outFileName;
   set indntlvl 0
   set indntsp 1
   set cntnu 0
   set filein [open $inFileName "r"]
   set fileout [open $outFileName "w"]
   while {[gets $filein linein] >= 0} {
     set newline [string trim $linein]
     if {[string index $newline 0] == {#}} {
       puts $fileout $linein
     } elseif {[string index $newline 0] == "\}"} {
       set indntsp [expr $indntsp - $nrspaces]
       if {$indntsp > 1} {
         set lineout {}
         while {[string length $lineout] < [expr $indntsp - 1]} {
           set lineout [format "$lineout "]
         }
         set lineout [format "%s %s" $lineout $newline]
       } else {
         set lineout $newline
       }
       puts $fileout $lineout
       if {[string length $newline] > 2} {
         set indntsp [expr $indntsp + $nrspaces]
       }
     } else {
       set nd [expr [string length $newline] - 1]
       while {[string index $newline $nd] == "\\"} {
         set newline [string trim [string range $newline 0 [expr \
           [string length $newline] - 2]]]
         gets $filein linein
         set aline [string trim $linein]
         set newline [format "%s %s" $newline $aline]
         set nd [expr [string length $newline] - 1]
       }
       set lineout {}
       while {[string length $lineout] < [expr $indntsp - 1]} {
         set lineout [format "$lineout "]
       }
       set nd [string length $newline]
       set ist 0
       while {$ist < $nd} {
         set ind [expr $ist + 1]
         while {[string index $newline $ind] > " "} {
           incr ind
           if {$ind > $nd} {
             break
           }
         }
         incr ind -1
         set item [string range $newline $ist $ind]
         if {[expr [string length $lineout] + [string length $item]] \
           > 68} {
           set lineout [format "%s \\" $lineout]
           puts $fileout $lineout
           set lineout {}
           while {[string length $lineout] < [expr $indntsp + \
             $nrspaces - 1]} {
             set lineout [format "$lineout "]
           }
         }
         set lineout [format "%s %s" $lineout $item]
         set ist [expr $ind + 2]
       }
       if {[string range [string trim $lineout] 0 5] == {global}} {
         if {$indentglobal == 0} {
           set lineout [string trim $lineout]
         }
       }
       if {[string range [string trim $lineout] 0 3] == {proc}} {
         if {$indentproc == 1} {
           set lineout [string trim $lineout]
           set aline {}
           while {[string length $aline] < $nrspaces} {
             set aline [format "$aline "]
           }
           set lineout [format "%s%s" $aline $lineout]
           set indntsp $nrspaces
         } else {
           set lineout [string trim $lineout]
           set indntsp 1
         }
       }
       puts $lineout
       puts $fileout $lineout
       set leftcnt 0
       set rightcnt 0
       for {set ix 0} {$ix < [string length $newline]} {incr ix} {
         set ltr [string index $newline $ix]
         if {$ltr == {\\}} {
           incr ix
         } elseif {$ltr == "\{"} {
           incr leftcnt
         } elseif {$ltr == "\}"} {
           incr rightcnt
         }
       }
       if {$leftcnt > $rightcnt} {
         set indntsp [expr $indntsp + (($leftcnt - $rightcnt) * \
           $nrspaces)]
       } elseif {$rightcnt > $leftcnt} {
         set indntsp [expr $indntsp - (($rightcnt - $leftcnt) * \
           $nrspaces)]
       }
     }
   }
#  exit
}

proc {main} {argc argv} {
global indentglobal;
global indentproc;
global nrspaces;
   set indentglobal 0
   set indentproc 0
   set nrspaces 2
}

proc {Window} {args} {
global vTcl
   set cmd [lindex $args 0]
   set name [lindex $args 1]
   set newname [lindex $args 2]
   set rest [lrange $args 3 end]
   if {$name == "" || $cmd == ""} {return}
   if {$newname == ""} {
     set newname $name
   }
   set exists [winfo exists $newname]
   switch $cmd {
     show {
       if {$exists == "1" && $name != "."} {wm deiconify $name; \
         return}
       if {[info procs vTclWindow(pre)$name] != ""} {
         eval "vTclWindow(pre)$name $newname $rest"
       }
       if {[info procs vTclWindow$name] != ""} {
         eval "vTclWindow$name $newname $rest"
       }
       if {[info procs vTclWindow(post)$name] != ""} {
         eval "vTclWindow(post)$name $newname $rest"
       }
     }
     hide    { if $exists {wm withdraw $newname; return} }
     iconify { if $exists {wm iconify $newname; return} }
     destroy { if $exists {destroy $newname; return} }
   }
}

#################################
# VTCL GENERATED GUI PROCEDURES
#

proc vTclWindow. {base} {
   if {$base == ""} {
     set base .
   }
    ###################
    # CREATING WIDGETS
    ###################
   wm focusmodel $base passive
   wm geometry $base 200x200+0+0
   wm maxsize $base 1156 849
   wm minsize $base 112 1
   wm overrideredirect $base 0
   wm resizable $base 1 1
   wm withdraw $base
   wm title $base "vt"
   wm protocol . WM_DELETE_WINDOW {exit}
    ###################
    # SETTING GEOMETRY
    ###################
}

proc vTclWindow.pretty {base} {
   if {$base == ""} {
     set base .pretty
   }
   if {[winfo exists $base]} {
     wm deiconify $base; return
   }
    ###################
    # CREATING WIDGETS
    ###################
   toplevel $base -class Toplevel
   wm focusmodel $base passive
   wm geometry $base 432x152+337+164
   wm maxsize $base 1156 849
   wm minsize $base 112 1
   wm overrideredirect $base 0
   wm resizable $base 1 1
   wm deiconify $base
   wm title $base "Pretty TCL"
   wm protocol .pretty WM_DELETE_WINDOW {exit}
   label $base.lab18 -borderwidth 1 -text {Input TCL File:}
   entry $base.ent19 -textvariable inFileName
   bind $base.ent19 <Key> {
     .pretty.but24 configure -state normal
     if {[file dirname $inFileName] != {}} {
       set outFileName [format "%s/new.tcl" [file dirname \
         $inFileName]]
     } else {
       set outFileName {new.tcl}
     }
   }
   label $base.lab20 -borderwidth 1 -text {# Spaces to Indent:}
   entry $base.ent21 -justify right -textvariable nrspaces
   checkbutton $base.che22 -text {Indent Global} -variable \
     indentglobal
   checkbutton $base.che23 -text {Indent Proc} -variable indentproc
   button $base.but24 -command MakeItPretty -state disabled -text Run
   label $base.lab17 -borderwidth 1 -text {Output TCL File:}
   entry $base.ent18 -textvariable outFileName
   button $base.but17 -text Browse -command {
     set inFileName [tk_getOpenFile]
     set outFileName [format "%s/new.tcl" [file dirname $inFileName]]
     .pretty.but24 configure -state normal
   }
    ###################
    # SETTING GEOMETRY
    ###################
   place $base.lab18 -x 10 -y 10 -anchor nw -bordermode ignore
   place $base.ent19 -x 135 -y 5 -width 226 -height 22 -anchor nw \
     -bordermode ignore
   place $base.lab20 -x 5 -y 70 -anchor nw -bordermode ignore
   place $base.ent21 -x 135 -y 65 -width 36 -height 22 -anchor nw \
     -bordermode ignore
   place $base.che22 -x 5 -y 90 -anchor nw -bordermode ignore
   place $base.che23 -x 5 -y 120 -anchor nw -bordermode ignore
   place $base.but24 -x 260 -y 90 -width 73 -height 31 -anchor nw \
     -bordermode ignore
   place $base.lab17 -x 10 -y 40 -anchor nw -bordermode ignore
   place $base.ent18 -x 135 -y 35 -width 226 -height 22 -anchor nw \
     -bordermode ignore
   place $base.but17 -x 370 -y 5 -width 51 -height 21 -anchor nw \
     -bordermode ignore
}

 Window show .
 Window show .pretty

 main $argc $argv
